/* testset.c generated by valac 0.46.6, the Vala compiler
 * generated from testset.vala, do not modify */

/* testset.vala
 *
 * Copyright (C) 2008  Jürg Billeter
 * Copyright (C) 2009  Didier Villevalois, Julien Peeters
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 * 	Didier 'Ptitjes' Villevalois <ptitjes@free.fr>
 * 	Julien Peeters <contact@julienpeeters.fr>
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define GEE_TYPE_TEST_CASE (gee_test_case_get_type ())
#define GEE_TEST_CASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_TEST_CASE, GeeTestCase))
#define GEE_TEST_CASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_TEST_CASE, GeeTestCaseClass))
#define GEE_IS_TEST_CASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_TEST_CASE))
#define GEE_IS_TEST_CASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_TEST_CASE))
#define GEE_TEST_CASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_TEST_CASE, GeeTestCaseClass))

typedef struct _GeeTestCase GeeTestCase;
typedef struct _GeeTestCaseClass GeeTestCaseClass;
typedef struct _GeeTestCasePrivate GeeTestCasePrivate;

#define TYPE_COLLECTION_TESTS (collection_tests_get_type ())
#define COLLECTION_TESTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLLECTION_TESTS, CollectionTests))
#define COLLECTION_TESTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLLECTION_TESTS, CollectionTestsClass))
#define IS_COLLECTION_TESTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLLECTION_TESTS))
#define IS_COLLECTION_TESTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLLECTION_TESTS))
#define COLLECTION_TESTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLLECTION_TESTS, CollectionTestsClass))

typedef struct _CollectionTests CollectionTests;
typedef struct _CollectionTestsClass CollectionTestsClass;
typedef struct _CollectionTestsPrivate CollectionTestsPrivate;

#define TYPE_SET_TESTS (set_tests_get_type ())
#define SET_TESTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SET_TESTS, SetTests))
#define SET_TESTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SET_TESTS, SetTestsClass))
#define IS_SET_TESTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SET_TESTS))
#define IS_SET_TESTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SET_TESTS))
#define SET_TESTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SET_TESTS, SetTestsClass))

typedef struct _SetTests SetTests;
typedef struct _SetTestsClass SetTestsClass;
typedef struct _SetTestsPrivate SetTestsPrivate;
enum  {
	SET_TESTS_0_PROPERTY,
	SET_TESTS_NUM_PROPERTIES
};
static GParamSpec* set_tests_properties[SET_TESTS_NUM_PROPERTIES];
typedef void (*GeeTestCaseTestMethod) (gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GeeTestCase {
	GObject parent_instance;
	GeeTestCasePrivate * priv;
};

struct _GeeTestCaseClass {
	GObjectClass parent_class;
	void (*set_up) (GeeTestCase* self);
	void (*tear_down) (GeeTestCase* self);
};

struct _CollectionTests {
	GeeTestCase parent_instance;
	CollectionTestsPrivate * priv;
	GeeCollection* test_collection;
};

struct _CollectionTestsClass {
	GeeTestCaseClass parent_class;
};

struct _SetTests {
	CollectionTests parent_instance;
	SetTestsPrivate * priv;
};

struct _SetTestsClass {
	CollectionTestsClass parent_class;
	void (*test_duplicates_are_ignored) (SetTests* self);
};

static gpointer set_tests_parent_class = NULL;

GType gee_test_case_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GeeTestCase, g_object_unref)
GType collection_tests_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CollectionTests, g_object_unref)
GType set_tests_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SetTests, g_object_unref)
SetTests* set_tests_construct (GType object_type,
                               const gchar* name);
CollectionTests* collection_tests_construct (GType object_type,
                                             const gchar* name);
void gee_test_case_add_test (GeeTestCase* self,
                             const gchar* name,
                             GeeTestCaseTestMethod test,
                             gpointer test_target,
                             GDestroyNotify test_target_destroy_notify);
void set_tests_test_duplicates_are_ignored (SetTests* self);
static void _set_tests_test_duplicates_are_ignored_gee_test_case_test_method (gpointer self);
static void set_tests_real_test_duplicates_are_ignored (SetTests* self);

static void
_set_tests_test_duplicates_are_ignored_gee_test_case_test_method (gpointer self)
{
	set_tests_test_duplicates_are_ignored ((SetTests*) self);
}

SetTests*
set_tests_construct (GType object_type,
                     const gchar* name)
{
	SetTests * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (SetTests*) collection_tests_construct (object_type, name);
	gee_test_case_add_test ((GeeTestCase*) self, "[Set] duplicates are ignored", _set_tests_test_duplicates_are_ignored_gee_test_case_test_method, g_object_ref (self), g_object_unref);
	return self;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
set_tests_real_test_duplicates_are_ignored (SetTests* self)
{
	GeeSet* test_set = NULL;
	GeeCollection* _tmp0_;
	GeeSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	_tmp0_ = ((CollectionTests*) self)->test_collection;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEE_TYPE_SET) ? ((GeeSet*) _tmp0_) : NULL);
	test_set = _tmp1_;
	_vala_assert (test_set != NULL, "test_set != null");
	_vala_assert (gee_collection_add ((GeeCollection*) test_set, "one"), "test_set.add (\"one\")");
	_vala_assert (gee_collection_contains ((GeeCollection*) test_set, "one"), "test_set.contains (\"one\")");
	_tmp2_ = gee_collection_get_size ((GeeCollection*) test_set);
	_tmp3_ = _tmp2_;
	_vala_assert (_tmp3_ == 1, "test_set.size == 1");
	_vala_assert (!gee_collection_add ((GeeCollection*) test_set, "one"), "! test_set.add (\"one\")");
	_vala_assert (gee_collection_contains ((GeeCollection*) test_set, "one"), "test_set.contains (\"one\")");
	_tmp4_ = gee_collection_get_size ((GeeCollection*) test_set);
	_tmp5_ = _tmp4_;
	_vala_assert (_tmp5_ == 1, "test_set.size == 1");
	_vala_assert (gee_collection_remove ((GeeCollection*) test_set, "one"), "test_set.remove (\"one\")");
	_vala_assert (!gee_collection_contains ((GeeCollection*) test_set, "one"), "! test_set.contains (\"one\")");
	_tmp6_ = gee_collection_get_size ((GeeCollection*) test_set);
	_tmp7_ = _tmp6_;
	_vala_assert (_tmp7_ == 0, "test_set.size == 0");
	_vala_assert (!gee_collection_remove ((GeeCollection*) test_set, "one"), "! test_set.remove (\"one\")");
	_vala_assert (!gee_collection_contains ((GeeCollection*) test_set, "one"), "! test_set.contains (\"one\")");
	_tmp8_ = gee_collection_get_size ((GeeCollection*) test_set);
	_tmp9_ = _tmp8_;
	_vala_assert (_tmp9_ == 0, "test_set.size == 0");
	_g_object_unref0 (test_set);
}

void
set_tests_test_duplicates_are_ignored (SetTests* self)
{
	g_return_if_fail (self != NULL);
	SET_TESTS_GET_CLASS (self)->test_duplicates_are_ignored (self);
}

static void
set_tests_class_init (SetTestsClass * klass,
                      gpointer klass_data)
{
	set_tests_parent_class = g_type_class_peek_parent (klass);
	((SetTestsClass *) klass)->test_duplicates_are_ignored = (void (*) (SetTests*)) set_tests_real_test_duplicates_are_ignored;
}

static void
set_tests_instance_init (SetTests * self,
                         gpointer klass)
{
}

GType
set_tests_get_type (void)
{
	static volatile gsize set_tests_type_id__volatile = 0;
	if (g_once_init_enter (&set_tests_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SetTestsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) set_tests_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SetTests), 0, (GInstanceInitFunc) set_tests_instance_init, NULL };
		GType set_tests_type_id;
		set_tests_type_id = g_type_register_static (TYPE_COLLECTION_TESTS, "SetTests", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&set_tests_type_id__volatile, set_tests_type_id);
	}
	return set_tests_type_id__volatile;
}

